/* Copyright 1994, 1995 David Koski, Cjin Lee, Barton Miller
 * All rights reserved
 *  
 * This software is furnished under the condition that it may not
 * be provided or otherwise made available to, or used by, any
 * other person.  No title to or ownership of the software is
 * hereby transferred.
 *
 * Any use of this software must include the above copyright notice.
 */

static char Copyright[] =
"@(#) Copyright 1994, 1995 David Koski, Cjin Lee, Barton Miller.\n\
 All rights reserved.\n";


/*
	We are not responsible for any damage this may cause.  Use at
	your own risk!

	Please see the Fuzz paper for documentation on how this works.
*/

#include <stdio.h>
#include <stdlib.h>

#ifndef RAND_MAX
/* some header files suck */
#define RAND_MAX (2147483647)
#endif

static int init = 0;

static int inMalloc = 0;		/* do not allow recursive calls to
					   malloc (ie from random) */

static float mallocFail = 1.0;		/* chance for malloc to fail */

static void libInit()
{
    char *p;
    
    if (init)
	return;
    
    init = 1;
    
    if ((p = getenv("SEED"))) {
	srandom(atoi(p));
    } else {
	srandom(time(NULL));
    }
    
    if ((p = getenv("MALLOC_FAIL"))) {
	mallocFail = atof(p);
    }
}

static float chance()
{
    return random() / (float) RAND_MAX;
}

void *realCalloc(size_t nmemb, size_t size);
void *realMalloc(size_t size);
void *realRealloc(void *ptr, size_t size);

void *malloc(size_t size)
{
    void *p;
    
    inMalloc ++;
    
    libInit();
    
    if (inMalloc < 2 && chance() <= mallocFail) {
	inMalloc --;
	return NULL;
    } else {
	p = realMalloc(size);
	inMalloc --;
	return p;
    }
}

void *calloc(size_t num, size_t size)
{
    void *p;
    
    inMalloc ++;
    
    libInit();
    
    if (inMalloc < 2 && chance() <= mallocFail) {
	inMalloc --;
	return NULL;
    } else {
	p = realCalloc(num, size);
	inMalloc --;
	return p;
    }
}

void *realloc(void *ptr, size_t size)
{
    void *p;
    
    inMalloc ++;
    
    libInit();
    
    if (inMalloc < 2 && chance() <= mallocFail) {
	inMalloc --;
	return NULL;
    } else {
	p = realRealloc(ptr, size);
	inMalloc --;
	return p;
    }
}
